#include <stdio.h>                  // printf()
#include <conio.h>                  // kbhit() getch()
#include <dos.h>                    // outportb()
#include <stdlib.h>                 // free()

#undef outportb
#undef outportw
#undef inportb
#undef inportw

#include "..\types\types.h"
#include "..\intel\i8259a.h"        // class InterruptController
#include "intr.h"












// user section of program
//


#define INTERRUPT 0x08

Bit32 ticks = 0;
Bit48 oldhandler;



// my interrupt handler
//
extern "C"
int my_handler(
    Bit32   ebp,
    Bit32   edi,
    Bit32   esi,
    Bit32    ds,
    Bit32    es,
    Bit32   edx,
    Bit32   ecx,
    Bit32   ebx,
    Bit32   eax,
    Bit32   eip,
    Bit32    cs,
    Bit32   flags
)
{
    // remember how many times this interrupt occurred
    //
    ticks++;

    // tell the Intel 8259A that the interrupt
    // has been handled, or else it will interrupt
    // the CPU again as soon as we return
    //
    InterruptController::acknowledge( 0 );

    // tell the assembly thunking code NOT
    // to chain to old interrupt handler
    //
    return 0;
}



int main( void )
{
    // test code for protected mode interrupt handlers
    //
    vfp thunk;

    oldhandler = getvect( INTERRUPT );
    printf( "interrupt %02X was at %04X:%08lX\n",
        INTERRUPT, oldhandler.selector, oldhandler.offset );

    thunk = make_thunk( my_handler, &oldhandler );
    if( thunk == NULL )
    {
        printf( "error!  cannot allocate interrupt thunk!\n" );
        return 1;
    }

    Bit48 pointer = { (Bit32)thunk, _CS };
    setvect( INTERRUPT, pointer );
    printf( "new handler installed, press any key to quit\n");

    while (!kbhit()) {
      printf("%cTimer ticks: %lu",13,ticks);
    }
    printf("\n");

    // cleanup for protected mode interrupt handler test code
    //
    printf("removing handler\n");
    setvect( INTERRUPT, oldhandler );
    free( thunk );

    // eat the keystroke they just did
    //
    getch();

    return 0;
}

