#include "..\types\types.h"             // Bit32 Bit16
#include "..\integrat\constant.h"       // DO_FOREGROUND_STATS


#define PHYS_RAM_START   0x00310000     // because I tell SMARTDRV to use 2MB and HIMEM.SYS XMS driver starts it at 0x110000
#define PHYS_RAM_END     0x08000000     // Joel (OC3MON) has 128M total
// #define PHYS_RAM_END     0x02000000     // Nevil has 32M total
#define PAGE_SIZE        0x1000         // always 4K bytes

#ifdef __cplusplus
extern "C" {
#endif

Bit32 get_limit( Bit16 selector );
Bit32 get_base( Bit16 selector );
void *map_physical( Bit32 physical, Bit32 bytes, Bit32 *mem_handle_ptr );
void unmap_physical( Bit32 bytes, Bit32 mem_handle );
Bit32 flat_to_linear( void *pointer );
Bit16 lock_linear( Bit32 pointer, Bit32 length );
Bit16 unlock_linear( Bit32 pointer, Bit32 length );

#ifdef __cplusplus
}
#endif

