/* 1530, Tue 15 Jul 97

   Globals for multiple packet drivers (32-bit version)

   Nevil Brownlee, The University of Auckland */

#define EN_IP  1  /* IP enabled    EN_ bits */
#define EN_MT  2  /* Metering (promiscuous mode) */
#define EN_HP  4  /* Use 1.10 (high performance) driver */

#define MAX_PD  4  /* Max nbr of ethernet interfaces */
struct en_info {
   int type;     /* AU interface (EN_ defines) */
   int int_nbr;  /* Software interrupt number */
   int handle;   /* Packet driver handle */
   unsigned int SampleRate,  /* Sampling rate: 1 = meter every packet */
      sample_count;
   unsigned long npackets, nbytes;
   unsigned long lostpackets, noflowpackets;
   };

extern struct  /* Declared (and initialised) in pcpkt.c */
   en_info en_table[MAX_PD];

#ifndef ETH_MTU
#define ETH_MTU     1514  /* Defined in wattcp.h */
#endif
#ifndef __DPMI32__
typedef unsigned char  Bit8;
typedef unsigned short Bit16;

extern void
   pkt_ent_0(), pkt_ent_1(), pkt_ent_2(), pkt_ent_3();
#endif

#ifndef MAX_SUBID  /* Declared in snmplib\asn1.h */
struct c64 {
   unsigned long high;
   unsigned long low;
   };
typedef struct c64 counter64;
#endif

struct pbuf {  // IP packet queue structures
   struct pbuf *next;
   Bit8 state;
//      0        buffer available
//      1        buffer being filled by ethernet driver
//      2        buffer filled
//      3        buffer in use by application
   Bit8 unused;
   union {  /* NeTraMet packet arrival time */
      double d;
      counter64 c;
      } arrival_time;
   Bit8 data[ETH_MTU];
   };

/* #define BUF_HDR_LEN  (sizeof(struct pbuf *)+2*sizeof(Bit8)+2*sizeof(Bit32)) */
#define BUF_HDR_LEN  (sizeof(struct pbuf) - ETH_MTU)

struct bufq {
   struct pbuf *head, *tail;
   int len;
   };

extern struct bufq freeq;  /* Declared (and initialised) in pcpkt.c */
extern struct bufq readyq;


void enqueue(struct bufq *bq, struct pbuf *pb);  // Function prototypes
struct pbuf *dequeue(struct bufq *bq);

Bit8 far *get_pktbuf(Bit16 length_wanted);

Bit8 far *pkt_rcv_call1(Bit16 length_wanted,
   Bit16 lah_length, Bit8 far *eth_buff, Bit16 if_nbr);
   
void pkt_rcv_call2(Bit16 len, Bit8 far *buff, Bit16 if_nbr);

void au_send_mon(int length, unsigned char far *buffer);

int pkt_init(void);
